/**

GDevelop - Timed Event Extension
Copyright (c) 2011-2016 Florian Rival (Florian.Rival@gmail.com)
This project is released under the MIT License.
*/

#if defined(GD_IDE_ONLY) && !defined(GD_NO_WX_GUI)

#include "TimedEventEditorDlg.h"
#include "GDCore/IDE/Dialogs/EditExpressionDialog.h"

//(*InternalHeaders(TimedEventEditorDlg)
#include <wx/bitmap.h>
#include <wx/image.h>
#include <wx/intl.h>
#include <wx/settings.h>
#include <wx/string.h>
//*)
#include "GDCpp/Runtime/CommonTools.h"
#include "GDCpp/Runtime/Project/Layout.h"
#include "GDCpp/Runtime/Project/Project.h"

//(*IdInit(TimedEventEditorDlg)
const long TimedEventEditorDlg::ID_STATICBITMAP3 = wxNewId();
const long TimedEventEditorDlg::ID_STATICTEXT3 = wxNewId();
const long TimedEventEditorDlg::ID_PANEL1 = wxNewId();
const long TimedEventEditorDlg::ID_STATICLINE2 = wxNewId();
const long TimedEventEditorDlg::ID_STATICTEXT1 = wxNewId();
const long TimedEventEditorDlg::ID_TEXTCTRL1 = wxNewId();
const long TimedEventEditorDlg::ID_BITMAPBUTTON1 = wxNewId();
const long TimedEventEditorDlg::ID_STATICTEXT2 = wxNewId();
const long TimedEventEditorDlg::ID_TEXTCTRL2 = wxNewId();
const long TimedEventEditorDlg::ID_STATICLINE1 = wxNewId();
const long TimedEventEditorDlg::ID_BUTTON1 = wxNewId();
const long TimedEventEditorDlg::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(TimedEventEditorDlg, wxDialog)
//(*EventTable(TimedEventEditorDlg)
//*)
END_EVENT_TABLE()

TimedEventEditorDlg::TimedEventEditorDlg(wxWindow* parent,
                                         TimedEvent& event_,
                                         gd::Project& game_,
                                         gd::Layout& scene_)
    : eventEdited(event_), game(game_), scene(scene_) {
  //(*Initialize(TimedEventEditorDlg)
  wxFlexGridSizer* FlexGridSizer4;
  wxFlexGridSizer* FlexGridSizer3;
  wxFlexGridSizer* FlexGridSizer5;
  wxFlexGridSizer* FlexGridSizer2;
  wxFlexGridSizer* FlexGridSizer7;
  wxFlexGridSizer* FlexGridSizer6;
  wxFlexGridSizer* FlexGridSizer1;
  wxFlexGridSizer* FlexGridSizer17;

  Create(parent,
         wxID_ANY,
         _("Timed event"),
         wxDefaultPosition,
         wxDefaultSize,
         wxDEFAULT_DIALOG_STYLE,
         _T("wxID_ANY"));
  FlexGridSizer1 = new wxFlexGridSizer(0, 1, 0, 0);
  FlexGridSizer17 = new wxFlexGridSizer(0, 1, 0, 0);
  FlexGridSizer17->AddGrowableCol(0);
  Panel1 = new wxPanel(this,
                       ID_PANEL1,
                       wxDefaultPosition,
                       wxDefaultSize,
                       wxTAB_TRAVERSAL,
                       _T("ID_PANEL1"));
  Panel1->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_WINDOW));
  FlexGridSizer6 = new wxFlexGridSizer(0, 3, 0, 0);
  StaticBitmap3 = new wxStaticBitmap(
      Panel1,
      ID_STATICBITMAP3,
      wxBitmap(wxImage(_T("CppPlatform/Extensions/timedevent64.png"))),
      wxDefaultPosition,
      wxDefaultSize,
      wxNO_BORDER,
      _T("ID_STATICBITMAP3"));
  FlexGridSizer6->Add(
      StaticBitmap3, 1, wxALL | wxALIGN_RIGHT | wxALIGN_CENTER_VERTICAL, 5);
  StaticText3 =
      new wxStaticText(Panel1,
                       ID_STATICTEXT3,
                       _("Conditions and actions wiill only be executed\nwhen "
                         "the event is executed for a certain amount of time."),
                       wxDefaultPosition,
                       wxDefaultSize,
                       wxALIGN_CENTRE,
                       _T("ID_STATICTEXT3"));
  FlexGridSizer6->Add(
      StaticText3, 1, wxALL | wxALIGN_LEFT | wxALIGN_CENTER_VERTICAL, 5);
  Panel1->SetSizer(FlexGridSizer6);
  FlexGridSizer6->Fit(Panel1);
  FlexGridSizer6->SetSizeHints(Panel1);
  FlexGridSizer17->Add(
      Panel1,
      1,
      wxALL | wxEXPAND | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      0);
  StaticLine2 = new wxStaticLine(this,
                                 ID_STATICLINE2,
                                 wxDefaultPosition,
                                 wxSize(10, -1),
                                 wxLI_HORIZONTAL,
                                 _T("ID_STATICLINE2"));
  FlexGridSizer17->Add(
      StaticLine2,
      1,
      wxALL | wxEXPAND | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      0);
  FlexGridSizer1->Add(
      FlexGridSizer17,
      1,
      wxALL | wxEXPAND | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      0);
  FlexGridSizer2 = new wxFlexGridSizer(0, 1, 0, 0);
  FlexGridSizer2->AddGrowableCol(0);
  StaticText1 = new wxStaticText(
      this,
      ID_STATICTEXT1,
      _("Execute conditions and actions after ( in seconds ):"),
      wxDefaultPosition,
      wxDefaultSize,
      0,
      _T("ID_STATICTEXT1"));
  FlexGridSizer2->Add(
      StaticText1, 1, wxALL | wxALIGN_LEFT | wxALIGN_CENTER_VERTICAL, 5);
  FlexGridSizer4 = new wxFlexGridSizer(0, 3, 0, 0);
  FlexGridSizer4->AddGrowableCol(0);
  timeoutEdit = new wxTextCtrl(this,
                               ID_TEXTCTRL1,
                               wxEmptyString,
                               wxDefaultPosition,
                               wxDefaultSize,
                               0,
                               wxDefaultValidator,
                               _T("ID_TEXTCTRL1"));
  FlexGridSizer4->Add(
      timeoutEdit,
      1,
      wxALL | wxEXPAND | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      5);
  expressionBt =
      new wxBitmapButton(this,
                         ID_BITMAPBUTTON1,
                         wxBitmap(wxImage(_T("res/expressionicon.png"))),
                         wxDefaultPosition,
                         wxDefaultSize,
                         wxBU_AUTODRAW,
                         wxDefaultValidator,
                         _T("ID_BITMAPBUTTON1"));
  expressionBt->SetDefault();
  FlexGridSizer4->Add(
      expressionBt,
      1,
      wxALL | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      5);
  FlexGridSizer2->Add(
      FlexGridSizer4,
      1,
      wxALL | wxEXPAND | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      0);
  FlexGridSizer1->Add(
      FlexGridSizer2,
      1,
      wxALL | wxEXPAND | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      0);
  FlexGridSizer5 = new wxFlexGridSizer(0, 1, 0, 0);
  FlexGridSizer5->AddGrowableCol(0);
  StaticText2 = new wxStaticText(this,
                                 ID_STATICTEXT2,
                                 _("Name of the event ( optional ) :"),
                                 wxDefaultPosition,
                                 wxDefaultSize,
                                 0,
                                 _T("ID_STATICTEXT2"));
  FlexGridSizer5->Add(
      StaticText2, 1, wxALL | wxALIGN_LEFT | wxALIGN_CENTER_VERTICAL, 5);
  FlexGridSizer7 = new wxFlexGridSizer(0, 3, 0, 0);
  FlexGridSizer7->AddGrowableCol(0);
  nameEdit = new wxTextCtrl(this,
                            ID_TEXTCTRL2,
                            wxEmptyString,
                            wxDefaultPosition,
                            wxDefaultSize,
                            0,
                            wxDefaultValidator,
                            _T("ID_TEXTCTRL2"));
  FlexGridSizer7->Add(
      nameEdit,
      1,
      wxALL | wxEXPAND | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      5);
  FlexGridSizer5->Add(
      FlexGridSizer7,
      1,
      wxALL | wxEXPAND | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      0);
  FlexGridSizer1->Add(
      FlexGridSizer5,
      1,
      wxALL | wxEXPAND | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      0);
  StaticLine1 = new wxStaticLine(this,
                                 ID_STATICLINE1,
                                 wxDefaultPosition,
                                 wxSize(10, -1),
                                 wxLI_HORIZONTAL,
                                 _T("ID_STATICLINE1"));
  FlexGridSizer1->Add(
      StaticLine1,
      1,
      wxALL | wxEXPAND | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      0);
  FlexGridSizer3 = new wxFlexGridSizer(0, 3, 0, 0);
  okBt = new wxButton(this,
                      ID_BUTTON1,
                      _("Ok"),
                      wxDefaultPosition,
                      wxDefaultSize,
                      0,
                      wxDefaultValidator,
                      _T("ID_BUTTON1"));
  FlexGridSizer3->Add(
      okBt, 1, wxALL | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL, 5);
  cancelBt = new wxButton(this,
                          ID_BUTTON2,
                          _("Cancel"),
                          wxDefaultPosition,
                          wxDefaultSize,
                          0,
                          wxDefaultValidator,
                          _T("ID_BUTTON2"));
  FlexGridSizer3->Add(
      cancelBt,
      1,
      wxALL | wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL,
      5);
  FlexGridSizer1->Add(
      FlexGridSizer3, 1, wxALL | wxALIGN_RIGHT | wxALIGN_CENTER_VERTICAL, 0);
  SetSizer(FlexGridSizer1);
  FlexGridSizer1->Fit(this);
  FlexGridSizer1->SetSizeHints(this);

  Connect(ID_BITMAPBUTTON1,
          wxEVT_COMMAND_BUTTON_CLICKED,
          (wxObjectEventFunction)&TimedEventEditorDlg::OnexpressionBtClick);
  Connect(ID_BUTTON1,
          wxEVT_COMMAND_BUTTON_CLICKED,
          (wxObjectEventFunction)&TimedEventEditorDlg::OnokBtClick);
  Connect(ID_BUTTON2,
          wxEVT_COMMAND_BUTTON_CLICKED,
          (wxObjectEventFunction)&TimedEventEditorDlg::OncancelBtClick);
  //*)

  timeoutEdit->ChangeValue(eventEdited.GetTimeoutExpression());
  nameEdit->ChangeValue(eventEdited.GetName());
}

TimedEventEditorDlg::~TimedEventEditorDlg() {
  //(*Destroy(TimedEventEditorDlg)
  //*)
}

void TimedEventEditorDlg::OnokBtClick(wxCommandEvent& event) {
  eventEdited.SetTimeoutExpression(timeoutEdit->GetValue());
  eventEdited.SetName(nameEdit->GetValue());
  EndModal(1);
}

void TimedEventEditorDlg::OncancelBtClick(wxCommandEvent& event) {
  EndModal(0);
}

void TimedEventEditorDlg::OnexpressionBtClick(wxCommandEvent& event) {
  gd::EditExpressionDialog dialog(this, timeoutEdit->GetValue(), game, scene);
  if (dialog.ShowModal() == 1) timeoutEdit->ChangeValue(dialog.GetExpression());
}

#endif
